using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using System.Xml.Serialization;
using System.Xml;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WorkflowActions;
using Microsoft.Office.Workflow.Utility;

namespace ApprovalSequentialEdition
{
	public sealed partial class Workflow1: SequentialWorkflowActivity
	{
		public Workflow1()
		{
			InitializeComponent();
		}

        public Guid workflowId = default(System.Guid);
        public Microsoft.SharePoint.Workflow.SPWorkflowActivationProperties workflowProperties = new Microsoft.SharePoint.Workflow.SPWorkflowActivationProperties();
        public Guid task1_Id = default(System.Guid);
        public Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties task1_Properties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();
        public Guid task0_Id = default(System.Guid);
        public Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties task0_Properties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();

        //
        private string approveItemTitle;
        //ض
        private string rejectItemTitle;
        //ʶӦô
        private int runTask = 1;
        //ʶTask1Ƿͨ
        private bool task1Approved = false;
        //ʶTask2Ƿͨ
        private bool task2Approved = false;
        //ʶTask3Ƿͨ
        private bool task3Approved = false;
        //ʶTask3Ƿͨ
        private bool task4Approved = false;


        /// <summary>
        /// ȡʽΪ "ĳˣ" ַ
        /// </summary>
        /// <param name="task">TaskProperties</param>
        /// <returns>ָʽַ</returns>
        private string PersonSayComment(Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties task)
        {
            if (task.ExtendedProperties.Contains("comments"))
            {
                Microsoft.Office.Workflow.Utility.Contact c = Microsoft.Office.Workflow.Utility.Contact.FromName(task.AssignedTo, workflowProperties.Web);
                return c.DisplayName +
                    " : " +
                    task.ExtendedProperties["comments"] +
                    "\n";
            }
            else
                return "";
        }

        /// <summary>
        /// ȡContact Selectorеĵһϵ 
        /// </summary>
        /// <param name="assigneeXml">ϵϢxml</param>
        /// <returns>һϵ˵ƣûϵ򷵻ؿַ</returns>
        private string GetNextAssigneeDisplayname(string assigneeXml)
        {
            Microsoft.Office.Workflow.Utility.Contact[] contacts = Microsoft.Office.Workflow.Utility.Contact.ToContacts(assigneeXml, workflowProperties.Web);
            if (contacts[0] != null)
                return contacts[0].LoginName;
            else
                return "";
        }

        private void onWorkflowActivated_Invoked(object sender, ExternalDataEventArgs e)
        {
            workflowId = workflowProperties.WorkflowId;

            //
            approveItemTitle = " " + workflowProperties.Item.DisplayName;
            rejectItemTitle = workflowProperties.Item.DisplayName + " ˻أ";

            //лworkflowProperties.InitiationDataԵõʼʵ
            XmlSerializer xs = new XmlSerializer(typeof(Init));
            XmlTextReader xtr = new XmlTextReader(new System.IO.StringReader(workflowProperties.InitiationData));
            Init init = (Init)xs.Deserialize(xtr);

            //ʼϢTask0
            task0_Properties.Title = rejectItemTitle;
            task0_Properties.AssignedTo = workflowProperties.Originator;
            task0_Properties.ExtendedProperties["comments"] = init.comments;

            //Task1ıͷ
            task1_Properties.Title = approveItemTitle;
            task1_Properties.AssignedTo = init.contact[0].AccountId;
        }

        private void createTask1_MethodInvoking(object sender, EventArgs e)
        {
            //ΪTask1ָһµGUID
            task1_Id = Guid.NewGuid();
            //ָTask1ʹõı
            task1_Properties.TaskType = 1;
            //Task1еϢ
            task1_Properties.ExtendedProperties["beforeComments"] = PersonSayComment(task0_Properties);
            //Task1еϼϢ
            task1_Properties.ExtendedProperties["afterComments"] = PersonSayComment(task2_Properties) +
                PersonSayComment(task3_Properties) +
                PersonSayComment(task4_Properties);
        }

        private void onTaskChanged1_Invoked(object sender, ExternalDataEventArgs e)
        {
            //ȡTask1
            task1Approved = bool.Parse(task1_Properties.ExtendedProperties["approved"].ToString());

            if (task1Approved)
            {
                //ͨ,ʶ´δΪTask2Task2ıͷ
                runTask = 2;
                task2_Properties.Title = approveItemTitle;
                task2_Properties.AssignedTo = GetNextAssigneeDisplayname(task1_Properties.ExtendedProperties["contact"].ToString());
            }
            else
            {
                //ûͨ,ʶ´δΪTask0
                runTask = 0;
            }
        }

        private void createTask0_MethodInvoking(object sender, EventArgs e)
        {
            task0_Id = Guid.NewGuid();
            task0_Properties.TaskType = 0;
            task0_Properties.ExtendedProperties["afterComments"] = PersonSayComment(task1_Properties) +
                PersonSayComment(task2_Properties) +
                PersonSayComment(task3_Properties) +
                PersonSayComment(task4_Properties);
        }

        private void onTaskChanged0_Invoked(object sender, ExternalDataEventArgs e)
        {
            //ʶ´δΪTask1
            runTask = 1;
            task1_Properties.Title = approveItemTitle;
            task1_Properties.AssignedTo = GetNextAssigneeDisplayname(task0_Properties.ExtendedProperties["contact"].ToString());
        }

        public Guid task2_Id = default(System.Guid);
        public Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties task2_Properties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();

        private void createTask2_MethodInvoking(object sender, EventArgs e)
        {
            task2_Id = Guid.NewGuid();
            task2_Properties.TaskType = 2;
            task2_Properties.ExtendedProperties["beforeComments"] = PersonSayComment(task0_Properties) +
                PersonSayComment(task1_Properties);
            task2_Properties.ExtendedProperties["afterComments"] = PersonSayComment(task3_Properties) +
                PersonSayComment(task4_Properties);
        }

        private void onTaskChanged2_Invoked(object sender, ExternalDataEventArgs e)
        {
            task2Approved = bool.Parse(task2_Properties.ExtendedProperties["approved"].ToString());
            if (task2Approved)
            {
                runTask = 34;
                task3_Properties.Title = approveItemTitle;
                task3_Properties.AssignedTo = GetNextAssigneeDisplayname(task2_Properties.ExtendedProperties["contact1"].ToString());
                task4_Properties.Title = approveItemTitle;
                task4_Properties.AssignedTo = GetNextAssigneeDisplayname(task2_Properties.ExtendedProperties["contact2"].ToString());
            }
            else
            {
                runTask = 1;
                task1Approved = false;
                task1_Properties.Title = rejectItemTitle;
            }
            
        }

        private void final_Approved(object sender, ConditionalEventArgs e)
        {
            //ConditionedActivityGroupǷٴѭ
            e.Result = (task3Approved && task4Approved);
        }

        public Guid task3_Id = default(System.Guid);
        public Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties task3_Properties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();
        public Guid task4_Id = default(System.Guid);
        public Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties task4_Properties = new Microsoft.SharePoint.Workflow.SPWorkflowTaskProperties();

        private void createTask3_MethodInvoking(object sender, EventArgs e)
        {
            task3_Id = Guid.NewGuid();
            task3_Properties.TaskType = 3;
            task3_Properties.ExtendedProperties["beforeComments"] = PersonSayComment(task0_Properties) +
                PersonSayComment(task1_Properties) +
                PersonSayComment(task2_Properties);
        }

        private void createTask4_MethodInvoking(object sender, EventArgs e)
        {
            task4_Id = Guid.NewGuid();
            task4_Properties.TaskType = 3;
            task4_Properties.ExtendedProperties["beforeComments"] = PersonSayComment(task0_Properties) +
                PersonSayComment(task1_Properties) +
                PersonSayComment(task2_Properties);
        }

        private void customCode(object sender, EventArgs e)
        {
            if (!(task3Approved && task4Approved))
            {
                //λûжͨ,˻صTask1
                runTask = 1;
                task1Approved = false;
                task2Approved = false;
                task1_Properties.Title = rejectItemTitle;
            }
        }

        private void onTaskChanged3_Invoked(object sender, ExternalDataEventArgs e)
        {
            task3Approved = bool.Parse(task3_Properties.ExtendedProperties["approved"].ToString());
        }

        private void onTaskChanged4_Invoked(object sender, ExternalDataEventArgs e)
        {
            task4Approved = bool.Parse(task4_Properties.ExtendedProperties["approved"].ToString());
        }

        private void RunTask0(object sender, ConditionalEventArgs e)
        {
            e.Result = (runTask == 0);
        }

        private void RunTask1(object sender, ConditionalEventArgs e)
        {
            e.Result = (runTask == 1);
        }

        private void RunTask2(object sender, ConditionalEventArgs e)
        {
            e.Result = (runTask == 2);
        }

        private void RunTask34(object sender, ConditionalEventArgs e)
        {
            e.Result = (runTask == 34);
        }

    }

}
